unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, ExtCtrls, USPClient, USPUtils;

type
  TForm2 = class(TForm)
    PanelCmd: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    LogBox: TListBox;
    Label2: TLabel;
    TabSheet5: TTabSheet;
    Panel1: TPanel;
    Label3: TLabel;
    Button3: TButton;
    Label4: TLabel;
    Label5: TLabel;
    Button4: TButton;
    Button5: TButton;
    Image1: TImage;
    Label6: TLabel;
    OptEdit: TListBox;
    Label7: TLabel;
    EditName: TEdit;
    Label8: TLabel;
    EditValue: TEdit;
    Button6: TButton;
    Button8: TButton;
    USPClient: TUSPClient;
    Users: TListView;
    Button10: TButton;
    IPList: TListBox;
    IPEdit: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button9: TButton;
    Label1: TLabel;
    GroupBox1: TGroupBox;
    Label9: TLabel;
    Button7: TButton;
    Button12: TButton;
    Button13: TButton;
    TabSheet2: TTabSheet;
    Label10: TLabel;
    LVGrp: TListView;
    Button11: TButton;
    Button14: TButton;
    LVAcc: TListView;
    Label11: TLabel;
    Button15: TButton;
    Button16: TButton;
    Button17: TButton;
    Button18: TButton;
    Button19: TButton;
    Button20: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure IPListClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure OptEditClick(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button16Click(Sender: TObject);
    procedure Button14Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

uses Unit1;

{$R *.DFM}

procedure TForm2.FormCreate(Sender: TObject);
begin
  USPClient.UserPassword:=p;
  USPClient.UserLogin:=u;
  USPClient.ServHost:=s;
  if not USPClient.Open
  then ShowMessage('  .');
end;

procedure TForm2.FormDestroy(Sender: TObject);
begin
  USPClient.Close;
end;

procedure TForm2.IPListClick(Sender: TObject);
begin
  if IPList.ItemIndex>-1 then IPEdit.Text:=IPList.Items.Strings[IPList.ItemIndex];
end;

procedure TForm2.Button1Click(Sender: TObject);
begin
  if (IPList.Items.IndexOf(IPEdit.text)<0)and(IPEdit.text<>'') then begin
    USPClient.SrvCall('AddIP',[IPEdit.text]);
    IPList.Items.Add(IPEdit.text);
  end;
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  if IPList.Items.IndexOf(IPEdit.text)>-1 then begin
    USPClient.SrvCall('DelIP',[IPEdit.text]);
    IPList.Items.Delete(IPList.Items.IndexOf(IPEdit.text));
  end;
end;

procedure TForm2.Button3Click(Sender: TObject);
begin
  Close;
end;

procedure TForm2.Button4Click(Sender: TObject);
var PAK:TPacket;
begin
  PAK:=USPClient.SrvCall('GetLog',[]);
  LogBox.Items.Text:=PAK.Plain;
  PAK.Free;
end;

procedure TForm2.Button5Click(Sender: TObject);
var PAK:TPacket;
begin
  PAK:=USPClient.SrvCall('GetUsers',[]);
  USPUtils.ShowAsListView(PAK,Users);
  PAK.Free;
end;

procedure TForm2.OptEditClick(Sender: TObject);
var s,d:string; k:integer;
begin
  if OptEdit.ItemIndex>-1 then begin
    s:=OptEdit.Items.Strings[OptEdit.ItemIndex]; d:=s;
    k:=Pos('=',s); s:=Copy(s,1,k-1); Delete(d,1,k);
    EditName.Text:=s;
    EditValue.Text:=d;
  end;
end;

procedure TForm2.Button6Click(Sender: TObject);
begin
  USPClient.SrvCall('SetINI',[EditName.Text,EditValue.Text]);
  OptEdit.Items.Values[EditName.Text]:=EditValue.Text;
end;

procedure TForm2.Button8Click(Sender: TObject);
var PAK:TPacket;
begin
  PAK:=USPClient.SrvCall('GetINI',[]);
  OptEdit.Items.Text:=PAK.Plain;
  PAK.Free;
end;

procedure TForm2.Button9Click(Sender: TObject);
var PAK:TPacket;
begin
  PAK:=USPClient.SrvCall('GetIPs',[]);
  IPList.Items.Text:=PAK.Plain;
  PAK.Free;
end;

procedure TForm2.Button7Click(Sender: TObject);
begin
  USPClient.SrvCall('Sleep',[]);
end;

procedure TForm2.Button12Click(Sender: TObject);
begin
  USPClient.SrvCall('Wake',[]);
end;

procedure TForm2.Button13Click(Sender: TObject);
begin
  USPClient.SrvCall('Restart',[]);
end;

procedure TForm2.Button10Click(Sender: TObject);
begin
  if Users.Selected<>nil then begin
    USPClient.SrvCall('CloseUser',[Users.Selected.SubItems[5]]);
    Button5Click(nil);
  end;
end;

procedure TForm2.Button16Click(Sender: TObject);
var PAK:TPacket;
begin
  PAK:=USPClient.SrvCall('GetGroups',[]);
  USPUtils.ShowAsListView(PAK,LVGrp);
  PAK.Free;
end;

procedure TForm2.Button14Click(Sender: TObject);
var PAK:TPacket;
begin
  PAK:=USPClient.SrvCall('GetAccounts',[]);
  USPUtils.ShowAsListView(PAK,LVAcc);
  PAK.Free;
end;

procedure TForm2.PageControl1Change(Sender: TObject);
var i:integer;
begin
  i:=TPageControl(Sender).ActivePageIndex;
  case i of
    1: Button5Click(nil);
    2: begin Button16Click(nil); Button14Click(nil); end;
    3: begin Button8Click(nil); Button9Click(nil); end;
    4: Button4Click(nil);
  end;
end;

end.
