unit USPEvent;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, USPUtils;

type

  TUSPCall = procedure(User: TUSPUser; Par:TStrings; var Result:TStrings) of object;

  TUSPEvent = class(TComponent)
  private
    FPar: TStrings;
    FParCount: integer;
    FOnCall: TUSPCall;
    FHelp: string;
  protected
  public
    USPResult: TStrings;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetParameters(Par:string);
    function GetPar(i:integer):string;
    property Par[i:integer]:string read GetPar;
    procedure Call(User: TUSPUser);
  published
    property ParCount: integer read FParCount write FParCount;
    property OnCall: TUSPCall read FOnCall write FOnCall;
    property Help: string read FHelp write FHelp;
  end;

procedure Register;

implementation

{ TUSPEvent }

constructor TUSPEvent.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FPar:=TStringList.Create;
  USPResult:=TStringList.Create;
end;

destructor TUSPEvent.Destroy;
begin
  FPar.Free;
  USPResult.Free;
  inherited  Destroy;
end;

procedure TUSPEvent.SetParameters(Par:string);
begin
  FPar.Text:=Par;
end;

function TUSPEvent.GetPar(i:integer):string;
begin
  if (-1<i)and(i<FPar.Count)
  then Result:=FieldDecode(FPar[i])
  else Result:='';
end;

procedure TUSPEvent.Call(User: TUSPUser);
begin
  USPResult.Clear;
  if Assigned(FOnCall)
  then FOnCall(User,FPar,USPResult);
end;

procedure Register;
begin
  RegisterComponents('USP', [TUSPEvent]);
end;

end.
