unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, ExtCtrls, StdCtrls, USPUtils, muiPropView, USPClient,
  Buttons;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Saveas1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    OD: TOpenDialog;
    SD: TSaveDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Tree: TTreeView;
    Text: TMemo;
    USP: TUSPClient;
    Connection1: TMenuItem;
    Open2: TMenuItem;
    Disconnect1: TMenuItem;
    SrvCmd: TPanel;
    Label1: TLabel;
    TabSheet3: TTabSheet;
    Table: TListView;
    Cmd: TComboBox;
    SpeedButton1: TSpeedButton;
    Panel1: TPanel;
    Splitter1: TSplitter;
    Bevel1: TBevel;
    PV: TListView;
    procedure Open1Click(Sender: TObject);
    procedure TreeChange(Sender: TObject; Node: TTreeNode);
    procedure Open2Click(Sender: TObject);
    procedure Disconnect1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure CmdKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  PAK:TPacket;

implementation

uses Unit2;

{$R *.DFM}

procedure TForm1.Open1Click(Sender: TObject);
begin
  if OD.Execute then begin
    Text.Lines.LoadFromFile(OD.FileName);
    if PAK<>nil then PAK.Free;
    PAK:=TPacket.Create(Text.Lines.Text);
    USPUtils.ShowAsTreeView(PAK,Tree,nil,false);
    USPUtils.ShowAsTable(PAK,Table,'');
  end;
end;

procedure TForm1.TreeChange(Sender: TObject; Node: TTreeNode);
var k:integer; LI:TListItem; s,d:string;
begin
  if (Tree.Selected<>nil)and(TPacket(Tree.Selected.Data)<>nil) then begin
    PV.Items.BeginUpdate;
    PV.Items.Clear;
    s:=TPacket(Tree.Selected.Data).Plain;
    while Pos(']',s)>0 do begin
      d:=Trim(GetStrLine(']',s));
      k:=Pos('[',d);
      if k>0 then begin
        LI:=PV.Items.Add; LI.Caption:=Copy(d,1,k-1);
        Delete(d,1,k); LI.SubItems.Add(d);
      end;
    end;
    PV.Items.EndUpdate;
  end;
end;

procedure TForm1.Open2Click(Sender: TObject);
begin
  Form2.ShowModal;
  if Form2.Tag=1 then begin
    USP.ServHost:=Form2.Host.Text;
    USP.Protocol:=Form2.Proto.Text;
    USP.Port:=StrToInt(Form2.Port.Text);
    USP.UserLogin:=Form2.Login.Text;
    USP.UserPassword:=Form2.Password.Text;
    if not USP.Open then ShowMessage('   ')
    else SrvCmd.Visible:=true;
  end;
end;

procedure TForm1.Disconnect1Click(Sender: TObject);
begin
  USP.Close;
  SrvCmd.Visible:=false;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var s:string;
begin
  s:=USP.CmdExec(Cmd.Text+'.',PacketEnd);
  if PAK<>nil then PAK.Free;
  PAK:=TPacket.Create(s);
  Text.Text:=s;
  if Cmd.Items.IndexOf(Cmd.Text)=-1
  then Cmd.Items.Add(Cmd.Text);
  Cmd.Text:='';
  Tree.Selected:=nil;
  USPUtils.ShowAsTreeView(PAK,Tree,nil,false);
  USPUtils.ShowAsTable(PAK,Table,'');
end;

procedure TForm1.CmdKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key=13 then SpeedButton1Click(nil); 
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Cmd.Items.SaveToFile('Commands.lst');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  if FileExists('Commands.lst')
  then Cmd.Items.LoadFromFile('Commands.lst');
end;

end.
