unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Menus, Buttons, ExtCtrls, StdCtrls, ComCtrls, FileCtrl, WinSock,
  Registry, Db, DBTables, ScktComp, Grids, Dialogs, winsvc, ODUtils;

type

  TForm1 = class(TForm)
    Panel1: TPanel;
    PopupMenu2: TPopupMenu;
    Exit1: TMenuItem;
    Hide1: TMenuItem;
    Panel12: TPanel;
    SBM: TSpeedButton;
    SBX: TSpeedButton;
    Line1: TMenuItem;
    SBA: TSpeedButton;
    PanelCmd: TPanel;
    Query1: TQuery;
    TCPSS: TServerSocket;
    DB: TDatabase;
    PageControl1: TPageControl;
    TabSheet2: TTabSheet;
    Panel2: TPanel;
    Label1: TLabel;
    Bevel1: TBevel;
    Panel4: TPanel;
    Label2: TLabel;
    Bevel2: TBevel;
    IPList: TListBox;
    Panel5: TPanel;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    IPEdit: TEdit;
    OptEdit: TMemo;
    Panel3: TPanel;
    Bevel3: TBevel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Bevel4: TBevel;
    Panel6: TPanel;
    Label3: TLabel;
    Bevel5: TBevel;
    Panel7: TPanel;
    SpeedButton6: TSpeedButton;
    LogBox: TListBox;
    SpeedButton5: TSpeedButton;
    Query2: TQuery;
    TabSheet1: TTabSheet;
    procedure PreLoadTables;
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SBXClick(Sender: TObject);
    procedure SBMClick(Sender: TObject);
    procedure SBAClick(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TCPSSClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure TCPSSClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure TCPSSClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure TCPSSClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure IPListClick(Sender: TObject);
    procedure TCPSSAccept(Sender: TObject; Socket: TCustomWinSocket);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
  private
    procedure HotKeyDown(var Message: TMessage); message WM_HOTKEY;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Curdir,WinDir: String;
  {-com32-}
  c: array[1..100] of String[24];
  LN,sfHe,sfWi,sfLe,labcount: integer;
  tmp_ker_tdat: TK_TDAT_List;
  tmp_ker_tuom: TK_TUOM_List;
  tmp_ker_tpar: TK_TPAR_List;

const
  {ERROR Messages}
  ERROR_PAR  = '  ';
  ERROR_CMD  = '   ';
  ERROR_OPEN = '  ,  ';
  {Object Parameters Flags}
  OBJF_POINTER = 1;       //       
  OBJF_TEMP_POINTER = 2;  //       
  OBJF_READONLY = 4;      //  
  {Class Parameters Flags}
  CLAF_SET_POINTER = 1;       //    POINER   
  CLAF_SET_TEMP_POINTER = 2;  //    TEMP_POINER  
  CLAF_SET_READONLY = 4;      //    READONLY
  CLAF_INHERITABLE = 8;       //      

implementation

{$R *.DFM}

procedure Log(s:string);
var OutStream: TStream;
    FN:string;
begin
  FN:=CurDir+'oodbserv.log';
  if FileExists(FN)
  then OutStream:=TFileStream.Create(FN,fmOpenReadWrite)
  else OutStream:=TFileStream.Create(FN,fmCreate);
  OutStream.Position:=OutStream.Size;
  s:=DateToStr(Date)+'  '+TimeToStr(Time)+'  '+s+#13#10;
  OutStream.Write(s[1],length(s));
  OutStream.Free;
end;

procedure DoOpen1(s,uname,pwd:string);
begin
  with Form1 do begin
    if DB.Params.Values['password']<>pwd then begin
      DB.Close;
      DB.Params.Text:='USER NAME='+uname+#13#10+'password='+pwd;
      DB.Open;
    end;
    Query1.Close;
    Query1.SQL.Text:=s;
    Query1.Open;
  end;
end;

procedure OpenQuery1(s:string;row:integer);
var uname,pwd:string;
begin
  uname:=Form1.UG.Items.Item[row].caption;
  pwd:=GetStrBlock('[]',uname,true);
  DoOpen1(s,uname,pwd);
end;

procedure DoOpen2(s,uname,pwd:string);
begin
  with Form1 do begin
    if DB.Params.Values['password']<>pwd then begin
      DB.Close;
      DB.Params.Text:='USER NAME='+uname+#13#10+'password='+pwd;
      DB.Open;
    end;
    Query2.Close;
    Query2.SQL.Text:=s;
    Query2.Open;
  end;
end;

procedure OpenQuery2(s:string;row:integer);
var uname,pwd:string;
begin
  uname:=Form1.UG.Items.Item[row].caption;
  pwd:=GetStrBlock('[]',uname,true);
  DoOpen2(s,uname,pwd);
end;

{-----------------------[OODB]------------------------}

procedure TForm1.PreLoadTables;
var qr,par: string; i,k: integer;
    tmp_tdat: TK_TDAT;
    tmp_tuom: TK_TUOM;
    tmp_tpar: TK_TPAR;
begin
  if tmp_ker_tdat<>nil then tmp_ker_tdat.FreeWithSubItems;
  if tmp_ker_tuom<>nil then tmp_ker_tuom.FreeWithSubItems;
  if tmp_ker_tpar<>nil then tmp_ker_tpar.FreeWithSubItems;
  tmp_ker_tdat:=TK_TDAT_List.Create;
  tmp_ker_tuom:=TK_TUOM_List.Create;
  tmp_ker_tpar:=TK_TPAR_List.Create;

  try
    qr:='SELECT * FROM ker_tdat';
    DoOpen1(qr,OptEdit.Lines.Values['syslogin'],OptEdit.Lines.Values['syspass']);
    for i:=1 to Query1.RecordCount do begin
      tmp_tdat:=TK_TDAT.Create;
      tmp_tdat.tdat_id:=Query1.FieldByName('tdat_id').AsInteger;
      tmp_tdat.tdat_name:=Query1.FieldByName('tdat_name').AsString;
      tmp_ker_tdat.Add(tmp_tdat);
      Query1.Next;
    end;

    qr:='SELECT * FROM ker_tuom';
    DoOpen1(qr,OptEdit.Lines.Values['syslogin'],OptEdit.Lines.Values['syspass']);
    for i:=1 to Query1.RecordCount do begin
      tmp_tuom:=TK_TUOM.Create;
      tmp_tuom.tuom_id:=Query1.FieldByName('tuom_id').AsInteger;
      tmp_tuom.tuom_Name:=Query1.FieldByName('tuom_name').AsString;
      tmp_tuom.toum_Short:=Query1.FieldByName('tuom_short').AsString;
      tmp_ker_tuom.Add(tmp_tuom);
      Query1.Next;
    end;

    qr:='SELECT * FROM ker_tpar';
    DoOpen1(qr,OptEdit.Lines.Values['syslogin'],OptEdit.Lines.Values['syspass']);
    while not Query1.Eof do begin
      tmp_tpar:=TK_TPAR.Create;
      tmp_tpar.tpar_id:=Query1.FieldByName('tpar_id').AsInteger;
      tmp_tpar.tpar_Name:=Query1.FieldByName('tpar_name').AsString;
      tmp_tpar.tpar_ValList.Text:=Query1.FieldByName('tpar_ValList').AsString;
      tmp_tpar.tdat:=tmp_ker_tdat[Query1.FieldByName('tdat_id').AsInteger];
      tmp_tpar.tuom:=tmp_ker_tuom[Query1.FieldByName('tuom_id').AsInteger];
      tmp_ker_tpar.Add(tmp_tpar);
      Query1.Next;
    end;

  except
    log('Can not PreLoad tables using syslogin,syspass');
  end;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.FormCreate(Sender: TObject);
var buf:array[0..127] of Char; ShMsg: TMessage;
    WS:dword; OkSocket:bool;
begin
  Log('*** Service started');
  ShowWindow(Application.Handle,0);
  CurDir:=ExtractFilePath(ParamStr(0));
  GetWindowsDirectory(buf,SizeOf(buf)); WinDir:=buf;
  WinDir:=SPath(WinDir);

  {Setup}
  if FileExists(CurDir+'valid_ip.lst')
  then IPList.Items.LoadFromFile(CurDir+'valid_ip.lst');
  if FileExists(CurDir+'oodb.ini')
  then OptEdit.Lines.LoadFromFile(CurDir+'oodb.ini');
  TCPSS.Port:=StrToInt(OptEdit.Lines.Values['port']);
  DB.AliasName:=OptEdit.Lines.Values['alias'];

  {-com32-}
  C[1] :='LOGON';
  C[2] :='LOGOFF';
  //   
  C[3] :='GETALLCLASSES';       {}
  C[4] :='GETCLASSESBYPARENT';  {Parent}
  C[5] :='NEWCLASS';            {Parent,Name}
  C[6] :='DELCLASS';            {id}
  C[7] :='GETCLASSPROPS';       {id}
  C[8] :='GETCLASSPROP';        {id,PropID}
  C[9] :='SETCLASSPROP';        {id,PropID,Value}
  C[10]:='NEWCLASSPROP';        {id,PropID,Value}
  C[11]:='DELCLASSPROP';        {id,PropID}
  C[12]:='GETOBJECTSBYPARENT';  {parent,cla}
  C[13]:='GETOBJECTSBYCLASS';   {cla}
  C[14]:='GETOBJECTCLASS';      {id}
  C[15]:='NEWOBJECT';           {id,Parent,Cla,Name}
  C[16]:='GETOBJECTPROP';       {id,PropName}
  C[17]:='SETOBJECTPROP';       {id,PropName,Value}
  C[18]:='GETOBJECTPROPS';      {id,PropName}
  C[19]:='DELOBJECT';           {id}
  C[20]:='RENAMEOBJECT';        {id,NewName}
  C[21]:='RENAMECLASS';         {id,NewName}
  //  
  C[22]:='GETDATATYPES';        {}
  C[23]:='GETPROPTYPES';        {}
  C[24]:='NEWPROPTYPE';         {id,NewName}
  C[25]:='!res1';               {}
  C[26]:='SETPROPTYPE';         {id,tdat,tuom,Name,ValList}
  C[27]:='GETUNITSOFMEASURE';   {}
  C[28]:='NEWUNITOFMEASURE';    {name,short}
  C[29]:='!res2';               {id}
  C[30]:='SETUNITOFMEASURE';    {id,name,short}
  // system
  C[31]:='HELP';                {}
  C[32]:='SRVLOGON';            {password}
  C[33]:='SRVLOGOFF';           {}
  C[34]:='SRVGETUSERS';         {}
  C[35]:='SRVGETLOG';           {}
  C[36]:='SRVRESTART';          {}
  C[37]:='SRVGETIPS';           {}
  C[38]:='SRVADDIP';            {IPMask}
  C[39]:='SRVDELIP';            {IPMask}
  C[40]:='SRVGETINI';           {}
  C[41]:='SRVSETINI';           {VarName,VarValue}
  C[42]:='SRVINFO';             {}
  C[43]:='SRVREFRESH';             {}

  C[44]:='@@@';

{  GetInfo;
    
  GetAllClasses: ODClasses;
  GetClassesByParent(parent:integer): ODClasses;
  NewClass(parent:integer;Name:string);
  DelClass(id:integer);
  GetClassProps(id:integer;recursive:bool): ODProps;
  GetClassProp(id:integer;PropName:String): String;
  SetClassProp(id:integer;PropName,Value:String);
  NewClassProp(id:integer;PropName,Value:string);
  DelClassProp(id:integer;name:string);
  RenameClass(id:integer;NewName:string);

      
  GetObjectsByParent(parent:integer): ODObjects;
  GetObjectsByClass(cla:integer): ODObjects;
  GetObjectClass(id:integer): ODClass;
  NewObject(id,parent,cla:integer; name:string);
  GetObjectProp(id:integer;PropName:String): String;
  SetObjectProp(id:integer;PropName,Value:String);
  GetObjectProps(id:integer;PropName:String): ODProps;
  DelObject(id:integer);
  RenameObject(id:integer;NewName:string);
  }

  {--- from SHOW ---}

  sfHe:=Height;
  sfWi:=Width;
  sfLe:=Left;
  {HotKeys}
  {if not RegisterHotKey(Form1.handle,5,mod_alt or mod_control,act_vk)
  then begin
    ShowInfo('Shaman','HotKey ,   .');
    Halt(0);
  end;}

  WS:=GetWindowLong(Handle,GWL_STYLE);
  WS:=WS XOR WS_CAPTION;
  SetWindowLong(Handle,GWL_STYLE,WS);

  {--0--}
  TCPSS.Open;
  PreLoadTables;

end;

procedure TForm1.Panel1Click(Sender: TObject);
begin
  PopUpMenu2.Popup(Form1.Left,Form1.Top+Form1.Height);
end;

procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbLeft then begin
    ReleaseCapture;
    Form1.Perform(WM_SYSCOMMAND,$f012,0);
  end;
end;

procedure TForm1.SBXClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.SBMClick(Sender: TObject);
begin
  Application.Minimize;
//  ShowWindow(Application.Handle,0);
//  ShowWindow(Form1.Handle,0);
end;

procedure AppendUnic1(table,field:string;row:integer);
var d,name,pwd:string; i:dword;
begin
  name:=Form1.UG.Items.Item[row].caption;
  pwd:=GetStrBlock('[]',name,true);
  d:='USER NAME='+name+#13#10+'password='+pwd;
  with Form1 do begin
    if DB.Params.Values['password']<>pwd then begin
      DB.Close;
      DB.Params.Text:=d;
      DB.Open;
    end;
    Query1.Close;
    Query1.RequestLive:=false;
    Query1.SQL.Text:='SELECT max('+field+') from '+table;
    Query1.Open;
    i:=Query1.Fields[0].AsInteger+1;
    Query1.Close;
    Query1.RequestLive:=true;
    Query1.SQL.Text:='SELECT * from '+table+' where '+field+'='+IntToStr(i);
    Query1.Open;
    Query1.Append;
    Query1.FieldByName(field).AsInteger:=i;
  end;
end;

procedure AppendUnic2(table,field:string;row:integer);
var d,name,pwd:string; i:dword;
begin
  name:=Form1.UG.Items.Item[row].caption;
  pwd:=GetStrBlock('[]',name,true);
  d:='USER NAME='+name+#13#10+'password='+pwd;
  with Form1 do begin
    if DB.Params.Values['password']<>pwd then begin
      DB.Close;
      DB.Params.Text:=d;
      DB.Open;
    end;
    Query2.Close;
    Query2.RequestLive:=false;
    Query2.SQL.Text:='SELECT max('+field+') from '+table;
    Query2.Open;
    i:=Query2.Fields[0].AsInteger+1;
    Query2.Close;
    Query2.RequestLive:=true;
    Query2.SQL.Text:='SELECT * from '+table+' where '+field+'='+IntToStr(i);
    Query2.Open;
    Query2.Append;
    Query2.FieldByName(field).AsInteger:=i;
  end;
end;

function InIPList(s:string):bool;
var i:integer;
begin
  Result:=false;
  if Form1.IPList.Items.IndexOf(s)>-1 then Result:=true;
  if not Result then begin
    for i:=0 to Form1.IPList.Items.Count-1 do begin
      if IsLike(Form1.IPList.Items.Strings[i],s)
      then begin Result:=True; Exit; end;
    end;
  end;
end;

procedure Echo(s:string; row:integer; Socket: TCustomWinSocket);
begin
  Socket.SendText(s+#13#10);
  Form1.UG.Items.Item[row].SubItems[3]:=IntToStr(StrToInt(form1.UG.Items.Item[row].SubItems[3])+length(s)+2);
end;

procedure ComDo(S: String; row:integer; Socket: TCustomWinSocket);
var i,j,l,id,id_:integer;
    u,qr,co,pwd,name,par_:string;
    par,send: TStrings;
begin
  par:=TStringList.Create;
  send:=TStringList.Create;
  i:=1;
  l:=Pos('(',s);
  co:=UpperCase(Copy(s,1,l-1));
  //  
  par_:=GetStrBlock('()',s,false);
  l:=Pos(',',par_);
  if l>0 then begin
    while l>0 do begin
      par.Add(Copy(par_,1,l-1));
      Delete(par_,1,l);
      l:=Pos(',',par_);
    end;
    if par_<>'' then par.Add(par_);
  end else par.Add(par_);
  //  
  while (co<>C[i])and(i<44) do inc(i);
  case i of
  1 : begin //LOGON
        if par.Count=2 then begin
          name:=par[0]; pwd:=par[1];
          Form1.UG.Items.Item[row].caption:=name+'['+pwd+']';
          qr:='SELECT * FROM ker_tdat';
          try
            OpenQuery1(qr,row);
          except
            Send.Text:='Res[ERR_0002]';
          end;
          if Form1.Query1.Active
          then Send.Text:='Res[OK]';
        end else begin
          Send.Text:='Res[ERR_0003]';
        end;
      end;
  2 : begin //LOGOFF;
        Form1.UG.Items.Item[row].caption:='loggedoff';
        Send.Text:='Res[OK]';
      end;
  3 : begin //GETALLCLASSES      {}
        qr:='SELECT * FROM ker_classes ORDER BY cla_name';
        try
          OpenQuery1(qr,row);
          Send.Add('Res[OK] Model[large]');
          Send.Add('Part[Classes] Type[array] Count['+IntToStr(Form1.Query1.RecordCount)+']');
          for j:=1 to Form1.Query1.RecordCount do begin
            Send.Add('  ID['+IntToStr(Form1.Query1.FieldByName('cla_id').AsInteger)+'] Name['+Form1.Query1.FieldByName('cla_name').AsString+'] Parent['+Form1.Query1.FieldByName('cla_parent').AsString+']');
            if i<>Form1.Query1.RecordCount then Form1.Query1.Next;
          end;
          Send.Add('Endpart[Classes]');
        except
          Send.Text:='Res[ERR_0004]';
        end;
      end;
  4 : begin //GETCLASSESBYPARENT   {Parent}
        qr:='SELECT * FROM ker_classes WHERE cla_parent='+par[0]+' ORDER BY cla_name';
        try
          OpenQuery1(qr,row);
          for j:=1 to Form1.Query1.RecordCount do begin
            Send.Add('Class('+IntToStr(Form1.Query1.FieldByName('cla_id').AsInteger)+','+Form1.Query1.FieldByName('cla_name').AsString+','+Form1.Query1.FieldByName('cla_parent').AsString+')');
            Form1.Query1.Next;
          end;
          Echo(Send.Text,row,Socket);
        except
          Echo('Error('+ERROR_OPEN+')',row,Socket);
        end;
      end;
  5 : begin //NEWCLASS           {Parent,Name}
        qr:='SELECT * FROM ker_classes WHERE cla_name='+#39+par[1]+#39+' and cla_parent='+par[0];
        try
          OpenQuery1(qr,row);
          if Form1.Query1.RecordCount=0 then begin
            AppendUnic1('ker_classes','cla_id',row);
            j:=Form1.Query1.FieldByName('cla_id').AsInteger;
            Form1.Query1.FieldByName('cla_parent').AsInteger:=StrToInt(par[0]);
            Form1.Query1.FieldByName('cla_name').AsString:=par[1];
            Form1.Query1.Post;
            qr:='SELECT * FROM ker_parcla WHERE cla_id='+par[0];
            OpenQuery1(qr,row);
            while not Form1.Query1.Eof do begin
              AppendUnic2('ker_parcla','parcla_id',row);
              Form1.Query2.FieldByName('cla_id').AsInteger:=j;
              Form1.Query2.FieldByName('tpar_id').AsInteger:=Form1.Query1.FieldByName('tpar_id').AsInteger;
              Form1.Query2.FieldByName('parcla_value').AsString:=Form1.Query1.FieldByName('parcla_value').AsString;
              Form1.Query2.FieldByName('parcla_flag').AsString:=Form1.Query1.FieldByName('parcla_flag').AsString;
              Form1.Query2.Post;
              Form1.Query1.Next;
            end;
          end else Echo('Error(  )',row,Socket);
        except
          Echo('Error('+ERROR_OPEN+')',row,Socket);
        end;
      end;
  6 : begin //DELCLASS           {id}
        try
          Form1.Query1.RequestLive:=false;
          qr:='SELECT count(*) FROM ker_classes WHERE cla_parent='+par[0];
          OpenQuery1(qr,row);
          if Form1.Query1.Fields[0].AsInteger=0 then begin
            Form1.Query1.SQL.Text:='DELETE FROM ker_parcla WHERE cla_id='+par[0];
            Form1.Query1.ExecSQL;
            Form1.Query1.SQL.Text:='DELETE FROM ker_classes WHERE cla_id='+par[0];
            Form1.Query1.ExecSQL;
          end else Echo('Error(  ;   )',row,Socket);
        except
          Echo('Error('+ERROR_OPEN+')',row,Socket);
        end;
        Form1.Query1.RequestLive:=true;
      end;
  7 : begin //GETCLASSPROPS      {id}
        qr:='SELECT * FROM ker_parcla where cla_id='+par[0];
        try
          OpenQuery1(qr,row);
          while not Form1.Query1.Eof do begin
            Send.Add('Prop('+tmp_ker_tpar[Form1.Query1.FieldByName('tpar_id').AsInteger].tpar_Name+','+
                     SPCode(Form1.Query1.FieldByName('parcla_value').AsString)+')');
            Form1.Query1.Next;
          end;
          Echo(Send.Text,row,Socket);
        except
          Echo('Error('+ERROR_OPEN+')',row,Socket);
        end;
      end;
  8 : begin //GETCLASSPROP       {id,PropId}
        qr:='SELECT * FROM ker_parcla where cla_id='+par[0]+' and tpar_id='+par[1];
        try
          OpenQuery1(qr,row);
          if Form1.Query1.RecordCount<>0
          then Echo('Prop('+tmp_ker_tpar[Form1.Query1.FieldByName('tpar_id').AsInteger].tpar_Name+','+
                     SPCode(Form1.Query1.FieldByName('parcla_value').AsString)+')',row,Socket);
        except
          Echo('Error('+ERROR_OPEN+')',row,Socket);
        end;
      end;
  9 : begin //SETCLASSPROP       {id,PropId,Value}
        qr:='SELECT * FROM ker_parcla where cla_id='+par[0]+' and tpar_id='+par[1];
        try
          OpenQuery1(qr,row);
          if Form1.Query1.RecordCount<>0 then begin
            Form1.Query1.Edit;
            Form1.Query1.FieldByName('parcla_value').AsString:=par[2];
            Form1.Query1.Post;
          end;
        except
          Echo('Error('+ERROR_OPEN+')',row,Socket);
        end;
      end;
  10: begin //NEWCLASSPROP       {id,PropId,Value}
        qr:='SELECT * FROM ker_parcla where cla_id='+par[0]+' and tpar_id='+par[1];
        try
          OpenQuery1(qr,row);
          if Form1.Query1.RecordCount=0 then begin
            AppendUnic1('ker_parcla','parcla_id',row);
            Form1.Query1.FieldByName('tpar_id').AsInteger:=StrToInt(par[1]);
            Form1.Query1.FieldByName('cla_id').AsInteger:=StrToInt(par[0]);
            Form1.Query1.FieldByName('parcla_value').AsString:=par[2];
            Form1.Query1.Post;
          end;
        except
          Echo('Error('+ERROR_OPEN+')',row,Socket);
        end;
      end;
  11: begin //DELCLASSPROP       {id,PropID}
      end;
  12: begin //GETOBJECTSBYPARENT {parent,cla}
        if (par.count<2)or(par[1]='0')
        then qr:='SELECT * FROM ker_objects WHERE obj_parent='+par[0]+' ORDER BY obj_name'
        else qr:='SELECT * FROM ker_objects WHERE obj_parent='+par[0]+' and cla_id='+par[1]+' ORDER BY obj_name';
        try
          OpenQuery1(qr,row);
          for j:=1 to Form1.Query1.RecordCount do begin
            Send.Add('Object('+IntToStr(Form1.Query1.FieldByName('obj_id').AsInteger)+','+Form1.Query1.FieldByName('obj_name').AsString+','+Form1.Query1.FieldByName('cla_id').AsString+')');
            Form1.Query1.Next;
          end;
          Echo(Send.Text,row,Socket);
        except
          Echo('Error('+ERROR_OPEN+')',row,Socket);
        end;
      end;
  13: begin //GETOBJECTSBYCLASS  {cla}
      end;
  14: begin //GETOBJECTCLASS     {id}
      end;
  15: begin //NEWOBJECT          {Parent,Cla,Name}
        qr:='SELECT * FROM ker_objects WHERE obj_name='+#39+par[2]+#39+' and obj_parent='+par[0];
        Echo(qr,row,Socket);
        try
          OpenQuery1(qr,row);
          if Form1.Query1.RecordCount=0 then begin
            AppendUnic1('ker_objects','obj_id',row);
            Form1.Query1.FieldByName('obj_parent').AsInteger:=StrToInt(par[0]);
            Form1.Query1.FieldByName('cla_id').AsInteger:=StrToInt(par[1]);
            Form1.Query1.FieldByName('obj_name').AsString:=par[2];
            Form1.Query1.Post;
          end else Echo('Error(  )',row,Socket);
        except
          Echo('Error('+ERROR_OPEN+')',row,Socket);
        end;
      end;
  16: begin //GETOBJECTPROP      {id,PropName}
      end;
  17: begin //SETOBJECTPROP      {id,PropName,Value}
      end;
  18: begin //GETOBJECTPROPS     {id,PropName}
      end;
  19: begin //DELOBJECT          {id}
        try
          Form1.Query1.RequestLive:=false;
          qr:='SELECT count(*) FROM ker_objects WHERE obj_parent='+par[0];
          OpenQuery1(qr,row);
          if Form1.Query1.Fields[0].AsInteger=0 then begin
            Form1.Query1.RequestLive:=true;
            qr:='SELECT * FROM ker_obj WHERE obj_id='+par[0];
            OpenQuery1(qr,row);
            if Form1.Query1.RecordCount<>0
            then Form1.Query1.Delete
            else Echo('Error(  ,   )',row,Socket);
          end else Echo('Error(  ,  )',row,Socket);
        except
          Echo('Error('+ERROR_OPEN+')',row,Socket);
        end;
      end;
  20: begin //RENAMEOBJECT       {id,NewName}
        qr:='SELECT * FROM ker_objects WHERE obj_id='+par[0];
        Echo(qr,row,Socket);
        try
          OpenQuery1(qr,row);
          if Form1.Query1.RecordCount<>0 then begin
            Form1.Query1.Edit;
            Form1.Query1.FieldByName('obj_name').AsString:=par[1];
            Form1.Query1.Post;
          end else Echo('Error(      )',row,Socket);
        except
          Echo('Error('+ERROR_OPEN+')',row,Socket);
        end;
      end;
  21: begin //RENAMECLASS        {id,NewName}
        qr:='SELECT * FROM ker_classes WHERE cla_id='+par[0];
        Echo(qr,row,Socket);
        try
          OpenQuery1(qr,row);
          if Form1.Query1.RecordCount<>0 then begin
            Form1.Query1.Edit;
            Form1.Query1.FieldByName('cla_name').AsString:=par[1];
            Form1.Query1.Post;
          end else Echo('Error(      )',row,Socket);
        except
          Echo('Error('+ERROR_OPEN+')',row,Socket);
        end;
      end;
  22: begin //GETDATATYPES';       {}
        for j:=0 to tmp_ker_tdat.Count-1
        do Send.Add('Type('+IntToStr(tmp_ker_tdat[j].tdat_id)+','+
                          tmp_ker_tdat[j].tdat_Name+')');
        Echo(Send.Text,row,Socket);
      end;
  23: begin //GETPROPTYPES';        {}
        for j:=0 to tmp_ker_tpar.Count-1
        do Send.Add('PropType('+IntToStr(tmp_ker_tpar[j].tpar_id)+','+
                     tmp_ker_tpar[j].tpar_Name+','+
                     IntToStr(tmp_ker_tpar[j].tdat.tdat_id)+','+
                     IntToStr(tmp_ker_tpar[j].tuom.tuom_id)+','+
                     SPCode(tmp_ker_tpar[j].tpar_ValList.Text)+')');
        Echo(Send.Text,row,Socket);
      end;
  24: begin //NEWPROPTYPE';         {id,NewName}
      end;
  25: begin //!res1
      end;
  26: begin //SETPROPTYPE';         {id,tdat,tuom,Name,ValList}
      end;
  27: begin //GETUNITSOFMEASURE';  {}
        for j:=0 to tmp_ker_tuom.Count-1
        do Send.Add('UnitOM('+IntToStr(tmp_ker_tuom[j].tuom_id)+','+tmp_ker_tuom[j].tuom_Name+','+tmp_ker_tuom[j].toum_Short+')');
        Echo(Send.Text,row,Socket);
      end;
  28: begin //NEWUNITOFMEASURE';   {name,short}
      end;
  29: begin //!res2
      end;
  30: begin //SETUNITOFMEASURE';   {id,name,short}
      end;
  31: begin //HELP                {}
        Echo( '     '+#13#10+
             'function  GETALLCLASSES()                   procedure RENAMEOBJECT(id,NewName)'+#13#10+
             'function  GETCLASSESBYPARENT (Parent)       procedure RENAMECLASS(id,NewName) '+#13#10+
             'procedure NEWCLASS(Parent,Name)             function  GETDATATYPES()          '+#13#10+
             'procedure DELCLASS(id)                      procedure DELDATATYPE(id)         '+#13#10+
             'function  GETCLASSPROPS(id,recursive)       procedure NEWDATATYPE(id,NewName) '+#13#10+
             'function  GETCLASSPROP(id,PropName)         function  GETEVENTTYPES()         '+#13#10+
             'procedure SETCLASSPROP(id,PropName,Value)   procedure DELEVENTTYPE(id)        '+#13#10+
             'procedure NEWCLASSPROP(id,PropName,Value)   procedure NEVEVENTTYPE(id,NewName)'+#13#10+
             'procedure DELCLASSPROP(id,Name)             function  GETUNITSOFMEASURE()     '+#13#10+
             'function  GETOBJECTSBYPARENT(parent)        procedure NEWUNITOFMEASURE()      '+#13#10+
             'function  GETOBJECTSBYCLASS(cla)            procedure DELUNITOFMEASURE()      '+#13#10+
             'function  GETOBJECTCLASS(id)                procedure HELP()                  '+#13#10+
             'procedure NEWOBJECT(id,Parent,Cla,Name)     procedure LOGON(name,password)    '+#13#10+
             'function  GETOBJECTPROP(id,PropName)        procedure LOGOFF()                '+#13#10+
             'procedure SETOBJECTPROP(id,PropName,Value)  '+#13#10+
             'function  GETOBJECTPROPS(id,PropName)       '+#13#10+
             'procedure DELOBJECT(id)                     '+#13#10+
             'procedure SRVLOGON(password)                procedure SRVADDIP(IPMask)        '+#13#10+
             'procedure SRVLOGOFF()                       procedure SRVDELIP(IPMask)        '+#13#10+
             'function  SRVGETUSERS()                     function  SRVGETINI()             '+#13#10+
             'function  SRVGETLOG()                       procedure SRVSETINI(VarName,Value)'+#13#10+
             'procedure SRVRELOAD()                       function  SRVINFO()               '+#13#10+
             'function  SRVGETIPS()                       '+#13#10,row,Socket);
      end;
  32: begin //SRVLOGON';            {password}
        if Form1.OptEdit.Lines.Values['admin']=par[0] then begin
          log(Socket.RemoteAddress+'  Logged as admin');
          Form1.UG.Items[row].SubItems[4]:='+';
          Echo('State(  )',row,Socket);
        end else begin
          Echo('Error(    )',row,Socket);
        end;
      end;
  33: begin //SRVLOGOFF';           {}
        Form1.UG.Items[row].SubItems[4]:=' ';
        Echo('Error(  )',row,Socket);
      end;
  34: //SRVGETUSERS';         {}
      if Form1.UG.Items[row].SubItems[4]='+' then begin
        for j:=0 to Form1.UG.Items.Count-1
        do with Form1.UG.Items[j] do Send.Add(caption+'  '+Subitems[0]+'  '+Subitems[1]+'  '+Subitems[2]+'  '+Subitems[3]+'  '+Subitems[4]);
        Echo(Send.Text,row,Socket);
      end;
  35: //SRVGETLOG';           {}
      if Form1.UG.Items[row].SubItems[4]='+' then begin
        Form1.SpeedButton6Click(nil);
        Echo(Form1.LogBox.Items.Text,row,Socket);
      end;
  36: //SRVRESTART';          {}
      if Form1.UG.Items[row].SubItems[4]='+' then begin
        Echo('State( )',row,Socket);
        For j:=0 to form1.TCPSS.Socket.ActiveConnections-1 do begin
          form1.TCPSS.Socket.Connections[j].SendText('State(   )');
          form1.TCPSS.Socket.Connections[j].Close;
        end;
        Form1.tag:=500;
        Form1.Close;
      end;
  37: //SRVGETIPS';           {}
      if Form1.UG.Items[row].SubItems[4]='+' then begin
        Echo(Form1.IPList.Items.Text,row,Socket);
      end;
  38: //SRVADDIP';            {IPMask}
      if Form1.UG.Items[row].SubItems[4]='+' then begin
        Form1.IPEdit.Text:=par[0];
        Form1.SpeedButton3Click(nil);
      end;
  39: //SRVDELIP';            {IPMask}
      if Form1.UG.Items[row].SubItems[4]='+' then begin
        Form1.IPEdit.Text:=par[0];
        Form1.SpeedButton4Click(nil);
      end;
  40: //SRVGETINI';           {}
      if Form1.UG.Items[row].SubItems[4]='+' then begin
        Echo(Form1.OptEdit.Lines.Text,row,Socket);
      end;
  41: //SRVSETINI';           {VarName,Value}
      if Form1.UG.Items[row].SubItems[4]='+' then begin
        Form1.OptEdit.Lines.Values[par[0]]:=par[1];
      end;
  42: //SRVINFO';             {}
      if Form1.UG.Items[row].SubItems[4]='+' then begin
        Send.add('Now: '+DateToStr(Date)+'  '+TimeToStr(Time));
        Send.add('Users connected: '+IntToStr(Form1.UG.Items.Count));
        Echo(Send.Text,row,Socket);
      end;
  43: begin //SRVREFRESH';    {}
        Form1.OptEdit.Lines.SaveToFile(CurDir+'oodb.ini');
        Form1.PreLoadTables;
        For j:=0 to form1.TCPSS.Socket.ActiveConnections-1 do
        form1.TCPSS.Socket.Connections[j].SendText('State( )');
        Form1.DB.Close;
        Form1.DB.AliasName:=form1.OptEdit.Lines.Values['alias'];
      end;
  else
    Send.Text:='Res[ERR_0001]';
  end;
  Echo(Send.Text,row,Socket);
  par.Free;
  send.Free;
end;

procedure TForm1.SBAClick(Sender: TObject);
begin
  if Form1.WindowState<>wsMaximized
  then Form1.WindowState:=wsMaximized
  else Form1.WindowState:=wsNormal;
end;

procedure TForm1.HotKeyDown(var Message: TMessage);
var hw,a1:dword;
    WP: TWindowPlacement;
    t,w: string;
begin
{  s:=nil;
  case Message.WParam of
    1: S:=Desk1;
    5: begin
         if not Application.ShowMainForm then begin
           Application.ShowMainForm:=true;
           Form1.Show;
           w:=VarSet.Values['Shaman.OnFirstActivate'];
           if FileExists(w) then DoFile(w,false);
         end;
         SMsg(Form1.Handle,WM_SYSCOMMAND,SC_RESTORE,0);
         ShowWindow(Application.Handle,0);
         SwitchToThisWindow(Form1.handle,True);
       end;
    32..128: if HotList.Count-1>=Message.WParam-32 then begin
      t:=HotList[Message.WParam-32];
      a1:=Pos(' ',t); Delete(t,1,a1);
      ComDo(t);
    end;
  end;
  }
end;

procedure TForm1.MenuItem4Click(Sender: TObject);
var s:string;
begin
{  s:='.ski';
  InputString('Open command list','File name:',s);
  If FileExists(s) then ComList.Items.LoadFromFile(s)
  else ShowInfo('Error','File not found.');}
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  OptEdit.Lines.SaveToFile(CurDir+'oodb.ini');
  TCPSS.Close;
  if tag=500 then WinExec(PChar(ParamStr(0)),SW_SHOW);
end;

procedure TForm1.TCPSSClientConnect(Sender: TObject; Socket: TCustomWinSocket);
var LI:TListItem;
begin
  Log(Socket.RemoteAddress+'  connected');
  LI:=UG.Items.Add;
  LI.Caption:='unknown';
  LI.SubItems.Text:=Socket.RemoteAddress+
    #13#10+''+#13#10+'0'+#13#10+'0'+#13#10+' '+#13#10+IntToStr(Socket.Handle);
  Echo('   '+#13#10+
       '----------------------------'+#13#10+
       '    Logon(name,password)'+#13#10+
       '    Help()',LI.Index,Socket);
end;

procedure TForm1.TCPSSClientDisconnect(Sender: TObject; Socket: TCustomWinSocket);
var i:integer;
begin
  Log(Socket.RemoteAddress+'  disconnected');
  i:=0;
  repeat
    if UG.Items.Item[i].SubItems[0]=Socket.RemoteAddress
    then UG.Items.Item[i].Delete;
    inc(i);
  until UG.Items.Count-1<i;
end;

procedure TForm1.TCPSSClientRead(Sender: TObject; Socket: TCustomWinSocket);
var i,k,l:integer; s,d:string;
begin
  i:=0;
  repeat
    if UG.Items.Item[i].SubItems[5]=IntToStr(Socket.Handle) then begin
      UG.Items.Item[i].SubItems[2]:=IntToStr(StrToInt(UG.Items.Item[i].SubItems[2])+Socket.ReceiveLength);
      s:=UG.Items.Item[i].SubItems[1]+Socket.ReceiveText;
      l:=Pos(#13#10,s);
      while l>0 do begin
        d:=Copy(s,1,l-1);
        Delete(s,1,l+1);
        ComDo(d,i,Socket);
        l:=Pos(#13#10,s);
      end;
      UG.Items.Item[i].SubItems[1]:=s;
    end;
    inc(i);
  until UG.Items.Count-1<i;
end;

procedure TForm1.TCPSSClientError(Sender: TObject; Socket: TCustomWinSocket; ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
  Log(Socket.RemoteAddress+'  Error #'+IntToStr(ErrorCode));
  ErrorCode:=0;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  if (IPList.Items.IndexOf(IPEdit.text)<0)and(IPEdit.text<>'')
  then IPList.Items.Add(IPEdit.text);
  IPList.Items.SaveToFile(CurDir+'valid_ip.lst');
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
begin
  if IPList.Items.IndexOf(IPEdit.text)>-1
  then IPList.Items.Delete(IPList.Items.IndexOf(IPEdit.text));
  IPList.Items.SaveToFile(CurDir+'valid_ip.lst');
end;

procedure TForm1.IPListClick(Sender: TObject);
begin
  if IPList.ItemIndex>-1 then IPEdit.Text:=IPList.Items.Strings[IPList.ItemIndex];
end;

procedure TForm1.TCPSSAccept(Sender: TObject; Socket: TCustomWinSocket);
begin
  if not(InIPList(Socket.RemoteAddress)) then begin
    Socket.SendText('Error( IP      )');
    Socket.Close;
  end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  OptEdit.Lines.SaveToFile(CurDir+'oodb.ini');
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  if FileExists(CurDir+'oodb.ini')
  then OptEdit.Lines.LoadFromFile(CurDir+'oodb.ini');
end;

procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
  if FileExists(CurDir+'oodbserv.log')
  then LogBox.Items.LoadFromFile(CurDir+'oodbserv.log');
  LogBox.ItemIndex:=LogBox.Items.Count-1;
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
  LogBox.Items.Clear;
  DeleteFile(CurDir+'oodbserv.log');
end;

end.
