unit UnitRA;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  USPFunction, USPUtils, USPServer;

type
  TRA = class(TDataModule)
    GetIPs: TUSPFunction;
    GetLog: TUSPFunction;
    GetInfo: TUSPFunction;
    GetUsers: TUSPFunction;
    Restart: TUSPFunction;
    AddIP: TUSPFunction;
    DelIP: TUSPFunction;
    GetINI: TUSPFunction;
    SetINI: TUSPFunction;
    USPServer1: TUSPServer;
    CloseUser: TUSPFunction;
    Sleep: TUSPFunction;
    Wake: TUSPFunction;
    USPServer2: TUSPServer;
    GetGroups: TUSPFunction;
    GetAccounts: TUSPFunction;
    GetPorts: TUSPFunction;
    SetAccount: TUSPFunction;
    SetGroup: TUSPFunction;
    DelAccount: TUSPFunction;
    DelGroup: TUSPFunction;
    NewAccount: TUSPFunction;
    AddGroup: TUSPFunction;
    upper: TUSPFunction;
    procedure GetIPsCall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
    procedure GetUsersCall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
    procedure GetInfoCall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
    procedure GetLogCall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
    procedure AddIPCall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
    procedure DelIPCall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
    procedure SetINICall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
    procedure GetINICall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
    procedure DataModuleCreate(Sender: TObject);
    procedure SleepCall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
    procedure CloseUserCall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
    procedure WakeCall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
    procedure GetGroupsCall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
    procedure GetAccountsCall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
    procedure GetPortsCall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
    procedure DelAccountCall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
    procedure SetGroupCall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
    procedure upperCall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  RA: TRA;

implementation

uses SrvUnit;

{$R *.DFM}

procedure TRA.GetIPsCall(User: TUSPUser; Par: TStrings; var Result: TStrings);
begin
  Result.Add('Res[OK] Model[large]');
  Result.Add('Part[IPS] Type[plain] Count['+IntToStr(IPList.Count)+']');
  Result.AddStrings(IPList);
  Result.Add('Endpart[IPS]');
end;

procedure TRA.GetUsersCall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
var i:integer;
begin
  Result.Add('Res[OK] Model[large]');
  Result.Add('Part[Users] Type[array] Count['+IntToStr(Users.Count)+']');
  for i:=0 to Users.Count-1 do
  with Users[i] do Result.Add('  User['+UserName+'] Service['+Service+
    '] IP['+Socket.RemoteAddress+'] Inc['+IntToStr(Incoming)+'] Out['+IntToStr(Outgoing)+
    '] Socket['+IntToStr(Socket.Handle)+']');
  Result.Add('Endpart[Users]');
end;

procedure TRA.GetInfoCall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
begin
  Result.Add('Res[OK] Model[small]');
  Result.Add('Usercount['+IntToStr(Users.Count)+'] Date['+DateToStr(Date)+'] Time['+TimeToStr(Time)+']');
end;

procedure TRA.GetLogCall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
var TMP:TStrings;
begin
  TMP:=TStringList.Create;
  TMP.LoadFromFile(CurDir+'USP.log');
  Result.Add('Res[OK] Model[large]');
  Result.Add('Part[Logfile] Type[plain]');
  Result.AddStrings(TMP);
  Result.Add('Endpart[Logfile]');
  TMP.Free;
end;

procedure TRA.AddIPCall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
begin
  if IPList.IndexOf(Par[0])=-1
  then IPList.Add(Par[0]);
  Result.Text:=ResOK;
  IPList.SaveToFile('Valid_ip.lst');
end;

procedure TRA.DelIPCall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
begin
  if IPList.IndexOf(Par[0])<>-1
  then IPList.Delete(IPList.IndexOf(Par[0]));
  Result.Text:=ResOK;
  IPList.SaveToFile('Valid_ip.lst');
end;

procedure TRA.SetINICall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
begin
  INI.Values[par[0]]:=Par[1];
  Result.Text:=ResOK;
  INI.SaveToFile(CurDir+'USP.ini');
end;

procedure TRA.GetINICall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
begin
  Result.Add('Res[OK] Model[large]');
  Result.Add('Part[INIfile] Type[plain]');
  Result.AddStrings(INI);
  Result.Add('Endpart[INIfile]');
end;

procedure TRA.DataModuleCreate(Sender: TObject);
begin
  USPServer1.Open;
  USPServer2.Open;
end;

procedure TRA.SleepCall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
begin
  Application.Restore;
  Application.Minimize;
  Result.text:=ResOK;
end;

procedure TRA.CloseUserCall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
var i:integer; U:TUSPUser;
begin
  i:=0; U:=nil;
  repeat
    if Users[i].Socket.Handle=THandle(StrToInt(Par[0]))
    then U:=Users[i];
    inc(i);
  until (i>Users.Count-1)or(U<>nil);
  if U<>nil then begin
    //U.Socket.Disconnect(Users[i].Socket.Handle);
    Users.Delete(i-1);
    U.Free;
  end;
  Result.text:=ResOK;
end;

procedure TRA.WakeCall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
begin
  Application.Restore;
  Result.text:=ResOK;
end;

procedure TRA.GetGroupsCall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
var i,l:integer; s:string;
begin
  Result.Add('Res[OK] Model[large]');
  Result.Add('Part[Groups] Type[array] Count[0]');
  for i:=0 to Acc.Count-1 do begin
    s:=Copy(Acc[i],1,5);
    if s='Group' then begin
      s:=Acc[i]; l:=Pos('=',s); s[l]:=' ';
      Result.Add(s);
    end;
  end;
  s:=Result[1]; SetStrField('Count',IntToStr(Result.Count-2),s);
  Result[1]:=s; Result.Add('Endpart[Groups]');
end;

procedure TRA.GetAccountsCall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
var i,l,j,k:integer; s:string;
begin
  Result.Add('Res[OK] Model[large]');
  Result.Add('Part[Accounts] Type[array] Count[0]');
  for i:=0 to Acc.Count-1 do begin
    s:=Copy(Acc[i],1,4);
    if s='User' then begin
      s:=Acc[i]; l:=Pos('=',s); s[l]:=' '; k:=0;
      for j:=0 to Users.Count-1 do
      if Users[j].UserName=GetStrField('User',s)
      then inc(k);
      Result.Add(s+' ConNum['+IntToStr(k)+']');
    end;
  end;
  s:=Result[1]; SetStrField('Count',IntToStr(Result.Count-2),s);
  Result[1]:=s; Result.Add('Endpart[Accounts]');
end;

procedure TRA.GetPortsCall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
var i:integer; s:string;
begin
  Result.Add('Res[OK] Model[large]');
  Result.Add('Part[Ports] Type[array] Count[0]');
  for i:=0 to ComponentCount-1 do if Components[i].ClassName='TUSPServer'
  then with TUSPServer(Components[i])
  do  Result.Add('Port['+IntToStr(Port)+'] Services['+Services+'] Timeout['+IntToStr(Timeout)+']');
  s:=Result[1]; SetStrField('Count',IntToStr(Result.Count-2),s);
  Result[1]:=s; Result.Add('Endpart[Ports]');
end;

procedure TRA.DelAccountCall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
var i:integer; s:string;
begin
//  Result.Text:=ResOK;
end;

procedure TRA.SetGroupCall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
begin
  windows.Sleep(5000);
  Result.Text:=ResOK;
end;

procedure TRA.upperCall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
begin
  Result.Add('Res[OK]');
  Result.Add('Upper['+Uppercase(par[0])+']');
end;

end.
