unit UnitRMU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  USPFunction, USPUtils;

type
  TRMU = class(TDataModule)
    SelectArea: TUSPFunction;
    GetVal: TUSPFunction;
    SetVal: TUSPFunction;
    DelVal: TUSPFunction;
    ClearArea: TUSPFunction;
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
    procedure SetValCall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
    procedure GetValCall(User: TUSPUser; Par: TStrings;
      var Result: TStrings);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  RMU: TRMU;
  VAL: TStrings;
  fn: string;

implementation

{$R *.DFM}

procedure TRMU.DataModuleCreate(Sender: TObject);
begin
  fn:='RMUvalues.mem';
  VAL:=TStringList.Create;
  if FileExists(fn)
  then VAL.LoadFromFile(fn);
end;

procedure TRMU.DataModuleDestroy(Sender: TObject);
begin
  VAL.SaveToFile(fn);
  VAL.Free;
end;

procedure TRMU.SetValCall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
var s:string;
begin
  s:=GetStrField('RMUArea',User.Values);
  if s='' then s:=User.UserName+'.'+Par[0]
  else s:=User.UserName+'.'+s+'.'+Par[0];
  VAL.Values[s]:=Par[1];
  Result.text:=ResOK;
end;

procedure TRMU.GetValCall(User: TUSPUser; Par: TStrings;
  var Result: TStrings);
var s:string;
begin
  s:=SmallPacket;
  SetStrField(par[0],VAL.Values[User.UserName+'.'+Par[0]],s);
  Result.text:=s;
end;

end.
